var WebBridgeApi = (function () {
    'use strict';

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
            if (ar || !(i in from)) {
                if (!ar) ar = Array.prototype.slice.call(from, 0, i);
                ar[i] = from[i];
            }
        }
        return to.concat(ar || Array.prototype.slice.call(from));
    }

    var TAG = "ijsbridge";
    var WebBridgeApiConstants;
    (function (WebBridgeApiConstants) {
        WebBridgeApiConstants["requireVersion"] = "requireVersion";
        WebBridgeApiConstants["sysinfo"] = "sysinfo";
        WebBridgeApiConstants["scanCode"] = "scanCode";
        WebBridgeApiConstants["authorize"] = "authorize";
        WebBridgeApiConstants["getUserInfo"] = "getUserInfo";
        WebBridgeApiConstants["fetch"] = "fetch";
        WebBridgeApiConstants["router"] = "router";
        WebBridgeApiConstants["showWebApp"] = "showWebApp";
        WebBridgeApiConstants["showToast"] = "showToast";
        WebBridgeApiConstants["showDialog"] = "showDialog";
        WebBridgeApiConstants["chooseImage"] = "chooseImage";
        WebBridgeApiConstants["chooseVideo"] = "chooseVideo";
        WebBridgeApiConstants["showImageViewer"] = "showImageViewer";
        WebBridgeApiConstants["showFullVideoPlayer"] = "showFullVideoPlayer";
        WebBridgeApiConstants["requestFullscreenVideoPlay"] = "requestFullscreenVideoPlay";
        WebBridgeApiConstants["checkPermission"] = "checkPermission";
        WebBridgeApiConstants["audioRecord"] = "audioRecord";
        WebBridgeApiConstants["share"] = "share";
        WebBridgeApiConstants["openLink"] = "openLink";
        WebBridgeApiConstants["showPickerMenu"] = "showPickerMenu";
        WebBridgeApiConstants["launchWechatProgram"] = "launchWechatProgram";
        WebBridgeApiConstants["getCurrentPosition"] = "getCurrentPosition";
        WebBridgeApiConstants["request"] = "request";
        WebBridgeApiConstants["registerAppEvent"] = "registerAppEvent";
        WebBridgeApiConstants["unRegisterAppEvent"] = "unRegisterAppEvent";
        WebBridgeApiConstants["triggerAppEvent"] = "triggerAppEvent";
        WebBridgeApiConstants["orientation"] = "orientation";
        WebBridgeApiConstants["connectDlna"] = "connectDlna";
        WebBridgeApiConstants["musicControl"] = "musicControl";
        WebBridgeApiConstants["readFile"] = "readFile";
        WebBridgeApiConstants["saveFile"] = "saveFile";
        WebBridgeApiConstants["unzip"] = "unzip";
        WebBridgeApiConstants["fileExists"] = "fileExists";
        WebBridgeApiConstants["previewVideo"] = "previewVideo";
        WebBridgeApiConstants["compressVideo"] = "compressVideo";
        WebBridgeApiConstants["compressImage"] = "compressImage";
        WebBridgeApiConstants["saveToAlbum"] = "saveToAlbum";
        WebBridgeApiConstants["storage"] = "storage";
    })(WebBridgeApiConstants || (WebBridgeApiConstants = {}));
    var BridgeMode;
    (function (BridgeMode) {
        BridgeMode[BridgeMode["Development"] = 1] = "Development";
        BridgeMode[BridgeMode["Production"] = 2] = "Production";
        BridgeMode[BridgeMode["Auto"] = 3] = "Auto";
    })(BridgeMode || (BridgeMode = {}));
    var SupportRouters;
    (function (SupportRouters) {
        SupportRouters["ad"] = "url";
        SupportRouters["article"] = "detail";
        SupportRouters["articlecate"] = "news_cate";
        SupportRouters["articlecates"] = "news_tabs";
        SupportRouters["govask"] = "govask_detail";
        SupportRouters["live"] = "live_detail";
        SupportRouters["liveindex"] = "live_index";
        SupportRouters["news"] = "detail";
        SupportRouters["ospsdetail"] = "govask_cate";
        SupportRouters["ospsindex"] = "osps_index";
        SupportRouters["radio"] = "radio";
        SupportRouters["tv"] = "tv";
        SupportRouters["url"] = "url";
        SupportRouters["web"] = "url";
        SupportRouters["zhengwuindex"] = "zhengwu_index";
        SupportRouters["zw"] = "detail";
        SupportRouters["newsclue"] = "newsclue";
        SupportRouters["newscluedetail"] = "newscluedetail";
        SupportRouters["snapshot"] = "snapshot";
        SupportRouters["snapshotdetail"] = "snapshotdetail";
        SupportRouters["yellow"] = "yellow";
    })(SupportRouters || (SupportRouters = {}));
    var Events;
    (function (Events) {
        Events["schemeOpen"] = "schemeOpen";
        Events["shake"] = "shake";
        Events["onMusicControl"] = "onMusicControl";
        Events["search"] = "search";
    })(Events || (Events = {}));

    var __Sate__ = {
        mode: BridgeMode.Auto
    };
    var __get_mode = function () {
        if (__Sate__.mode == BridgeMode.Auto) {
            if (('' + window.navigator.userAgent).indexOf("chuangqi") != -1) {
                return BridgeMode.Production;
            }
            else {
                return BridgeMode.Development;
            }
        }
        return __Sate__.mode;
    };

    var msgOffset = 0;
    var msgCache = [];
    var msgCallbacks = {};
    var bridges = {};
    var Message = (function () {
        function Message() {
            this.index = msgOffset++;
            this.params = null;
            this.data = null;
            this.api = null;
            this.ver = "2.6.10";
            this.callback = null;
            this.done = null;
        }
        return Message;
    }());
    var _post_message = function (messageData) {
        var win = window.ReactNativeWebView;
        console.log(TAG, "发送数据", messageData, JSON.stringify(messageData));
        if (win) {
            win.postMessage(JSON.stringify(messageData));
        }
    };
    var _bridge_flush = function () {
        if (msgCache.length == 0)
            return;
        var _msgCache = __spreadArray([], msgCache, true);
        msgCache.length = 0;
        var messageData = [];
        for (var i = 0; i < _msgCache.length; i++) {
            var msg = _msgCache[i];
            var json = null;
            if (msg instanceof Message) {
                json = { api: msg.api, data: msg.data, index: msg.index };
                if (msg.callback) {
                    msgCallbacks[msg.index] = msg;
                }
            }
            else {
                json = msg;
            }
            messageData.push(json);
        }
        _post_message(messageData);
    };
    var _bridge_request = function (api, data, cb) {
        if (cb === void 0) { cb = null; }
        api = "c2s_" + api;
        if (typeof data == "function") {
            cb = data;
            data = null;
        }
        var params = {};
        if (data && typeof data == "object") {
            for (var e in data) {
                if (e.substring(0, 1) == "_") {
                    params[e.substring(1)] = data[e];
                    delete data[e];
                }
            }
        }
        var msg = new Message();
        msg.data = data;
        msg.api = api;
        msg.params = params;
        if (cb) {
            msg.callback = cb;
        }
        msg.done = function () {
            delete msgCallbacks[msg.index];
        };
        msgCache.push(msg);
        _bridge_flush();
        return msg;
    };
    var _bridge_on = function (api, cb) {
        api = "s2c_" + api;
        bridges[api] || (bridges[api] = []);
        bridges[api].push(cb);
        return function () {
            var index = bridges[api].indexOf(cb);
            if (index != -1) {
                bridges[api].splice(index, 1);
            }
        };
    };
    var _receiveMessageHandle_define = function (json) {
        var api = json.api;
        if (!api || !bridges[api]) {
            return false;
        }
        for (var i in bridges[api]) {
            console.log(TAG, 'Web端接收接口调用', json);
            var handle = bridges[api][i];
            handle && handle(json, function (err, result) {
                var _json = Object.assign({}, json);
                _json.useApi = api;
                delete _json.api;
                _json.result = result;
                _json.error = err;
                msgCache.push(_json);
                _bridge_flush();
            });
        }
    };
    var _receiveMessageHandle_request_callback = function (json) {
        if (!json.index || !msgCallbacks[json.index])
            return false;
        var msg = msgCallbacks[json.index];
        console.log(TAG, '处理Web端定义接口回调', msg);
        if (!json.keepAlive) {
            msg.done();
        }
        else {
            console.warn(TAG, '会话保持!', msg);
        }
        msg.callback && msg.callback(json);
        return true;
    };
    var receiveMessageHandle = function (evt) {
        console.log(TAG, '接收到数据', evt);
        var messages;
        try {
            messages = JSON.parse(evt.data);
        }
        catch (e) {
            return;
        }
        if (!Array.isArray(messages)) {
            return;
        }
        for (var i in messages) {
            var json = messages[i];
            console.log(TAG, '接收到数据', json);
            if (_receiveMessageHandle_request_callback(json)) {
                continue;
            }
            if (_receiveMessageHandle_define(json)) {
                continue;
            }
            console.error(TAG, '无效的数据 忽略!');
        }
    };
    window.addEventListener("message", receiveMessageHandle);
    document.addEventListener("message", receiveMessageHandle);
    var _bridge_entries = {
        request: null,
        define: null
    };
    function createBridge() {
        if (_bridge_entries.request && _bridge_entries.define) {
            return _bridge_entries;
        }
        console.warn(TAG, "创建桥!");
        _bridge_entries.request = function (api, data, cb) {
            if (typeof data == "function") {
                cb = data;
                data = null;
            }
            return _bridge_request(api, data, function (json) {
                typeof cb == "function" &&
                    cb(json.error ? json.error : null, json.result);
            });
        };
        _bridge_entries.define = function (api, apiHandle) {
            return _bridge_on(api, function (json, cb) {
                apiHandle(json.data, function (err, result) {
                    typeof cb == "function" && cb(err, result);
                });
            });
        };
        _bridge_request("ready", "v2");
        _bridge_on("excute", function (json, cb) {
            var _res = window['ev' + 'al']("(function(){try{return ".concat(json.data, ";}catch(e){};return {error:'error',result:null};})()"));
            if (typeof (_res) == 'object' && typeof (_res.error) != 'undefined') {
                cb(_res.error, _res.result || null);
            }
            else {
                cb(null, _res);
            }
        });
        return _bridge_entries;
    }

    var __waitingForBridgeReady = function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, new Promise(function (r) {
                        var _a = createBridge(), request = _a.request, define = _a.define;
                        r({ req: request, def: define });
                    })];
                case 1: return [2, _a.sent()];
            }
        });
    }); };
    var __function_callbacks = {
        callbacks: {},
        offset: 1,
        invoke: function (idx, args) {
            __function_callbacks.callbacks[idx] &&
                __function_callbacks.callbacks[idx].apply(null, args);
        },
        trigger: function (idx, args) {
            __function_callbacks.invoke(idx, args);
            delete __function_callbacks.callbacks[idx];
        },
        filter: function (params) {
            window.ijsbridge_callbacks ||
                (window.ijsbridge_callbacks = {
                    invoke: __function_callbacks.invoke,
                    trigger: __function_callbacks.trigger
                });
            if (Array.isArray(params)) {
                for (var i in params) {
                    params[i] = __function_callbacks.filter(params[i]);
                }
                return params;
            }
            if (params && typeof params == "object") {
                for (var i in params) {
                    params[i] = __function_callbacks.filter(params[i]);
                }
                return params;
            }
            if (typeof params == "function") {
                __function_callbacks.offset++;
                __function_callbacks.callbacks[__function_callbacks.offset] = params;
                params = __function_callbacks.offset;
            }
            console.log(TAG, __function_callbacks);
            return params;
        },
    };
    var __request = function (api, params) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log(TAG, " call native __request", api, params);
                    return [4, new Promise(function (r, j) {
                            __request_callback(api, params, function (_a) {
                                var err = _a.err, result = _a.result;
                                r({ err: err, result: result });
                            });
                        })];
                case 1: return [2, _a.sent()];
            }
        });
    }); };
    var __request_callback = function (api, params, callback) { return __awaiter(void 0, void 0, void 0, function () {
        var bridge;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log(TAG, " call native __request_callback", api, params);
                    return [4, __waitingForBridgeReady()];
                case 1:
                    bridge = _a.sent();
                    params = __function_callbacks.filter(params);
                    bridge.req(api, params, function (err, result) {
                        console.log(TAG, " native __request result", err, result);
                        callback({ err: err, result: result });
                    });
                    return [2];
            }
        });
    }); };
    var __define = function (api, handle, times) {
        if (times === void 0) { times = -1; }
        return __awaiter(void 0, void 0, void 0, function () {
            var bridge, done;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log(TAG, " call native __define", api);
                        return [4, __waitingForBridgeReady()];
                    case 1:
                        bridge = _a.sent();
                        done = bridge.def(api, function (data, cb) { return __awaiter(void 0, void 0, void 0, function () {
                            var res, err, e_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        console.log(TAG, " call native __define", data);
                                        if (times != -1) {
                                            times = Math.max(times - 1, 0);
                                            times == 0 && done();
                                        }
                                        _a.label = 1;
                                    case 1:
                                        _a.trys.push([1, 3, , 4]);
                                        return [4, Promise.resolve(handle(data, done))];
                                    case 2:
                                        res = _a.sent();
                                        if (res && typeof res == "object" && typeof res.error != "undefined") {
                                            err = res.error;
                                            delete res.error;
                                            cb(err, res.result ? res.result : res);
                                        }
                                        else if (res === false) {
                                            cb("错误", res);
                                        }
                                        else {
                                            cb(null, res);
                                        }
                                        return [3, 4];
                                    case 3:
                                        e_1 = _a.sent();
                                        cb("" + e_1.message, null);
                                        return [3, 4];
                                    case 4: return [2];
                                }
                            });
                        }); });
                        return [2, done];
                }
            });
        });
    };

    var isObject = function (o) { return o && typeof (o) == 'object'; };
    var isUndefined = function (o) { return typeof (o) == 'undefined'; };

    var _userFix = function (u) {
        var _uMap = {
            orgID: "orgid",
            openID: "openid",
            groupID: "groupid",
            isLocked: "islock",
            isSlient: "isslient",
            hasSetInvite: "has_set_invite",
            inviteCode: "invite_code",
            inviteURL: "invite_url",
        };
        Object.keys(u).forEach(function (k) {
            var _k = _uMap[k];
            if (_k) {
                u[_k] = u[k];
            }
        });
    };
    var userHook = {
        keys: ['getUserInfo', 'authorize'],
        after: function (key, res) {
            var _a = res || {}, err = _a.err, result = _a.result;
            if (!isObject(result))
                return;
            _userFix(result);
            if (isObject(result.user)) {
                _userFix(result.user);
            }
            return { err: err, result: result };
        }
    };

    var betaData = {
        pic: "http://pic136.nipic.com/file/20170725/10673188_152559977000_2.jpg",
        video: "http://pic136.nipic.com/file/20170725/10673188_152559977000_2.mp4",
    };
    var apiDefaults = {
        sysinfo: {
            Brand: "品牌",
            SystemName: "系统名称",
            SystemVersion: "系统版本",
            BundleId: "报名",
            ApplicationName: "APP名称",
            BuildNumber: "编译版本",
            Version: "版本",
            ReadableVersion: "完整版本",
            DeviceName: "设备名称",
            UserAgent: "Agent",
            Carrier: "运营商",
            NetInfo: "网络环境",
            Config: {},
        },
        ping: true,
        requireVersion: true,
        scanCode: "",
        authorize: {
            avatar: betaData.pic,
            islock: "0",
            isslient: "0",
            nickname: "昵称",
            phone: "13000000000",
            token: "",
        },
        getUserInfo: {
            avatar: betaData.pic,
            islock: "0",
            isslient: "0",
            nickname: "昵称",
            phone: "13000000000",
            token: "",
        },
        fetch: { header: {}, body: "hello world" },
        request: { header: {}, body: "hello world" },
        router: true,
        showWebApp: true,
        showToast: true,
        showDialog: true,
        chooseImage: true,
        chooseVideo: true,
        showImageViewer: true,
        showFullVideoPlayer: true,
        requestFullscreenVideoPlay: true,
        musicControl: true,
        checkPermission: true,
        audioRecord: true,
        share: true,
        openLink: true,
        showPickerMenu: true,
        launchWechatProgram: true,
        getCurrentPosition: true,
        unRegisterAppEvent: true,
        triggerAppEvent: true,
        orientation: true,
        connectDlna: true,
        readFile: true,
        saveFile: true,
        unzip: true,
    };
    var defaultHook = {
        keys: '*',
        after: function (key, res) {
            if (__get_mode() != BridgeMode.Development)
                return;
            var err = null;
            var result = apiDefaults[key] ? apiDefaults[key] : {};
            return { err: err, result: result };
        }
    };

    var __registerAppEvent = function (input, listener) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (__get_mode() == BridgeMode.Production) {
                __request_callback(WebBridgeApiConstants.registerAppEvent, input, function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    typeof listener == "function" && listener.apply(void 0, args);
                });
                return [2];
            }
            typeof listener == "function" && listener({ err: "", result: true });
            return [2];
        });
    }); };
    var proxy = (function () {
        var _apis = {};
        var _hooks = [];
        var applyHook = function (hooks, state, key, data) { return __awaiter(void 0, void 0, void 0, function () {
            var originData, _a, _b, _i, i, fn, response;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        originData = data;
                        _a = [];
                        for (_b in hooks)
                            _a.push(_b);
                        _i = 0;
                        _c.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3, 4];
                        i = _a[_i];
                        fn = hooks[i][state];
                        if (!(typeof (fn) == 'function')) return [3, 3];
                        return [4, Promise.resolve(fn(key, data, originData))];
                    case 2:
                        response = _c.sent();
                        isUndefined(response) || (data = response);
                        _c.label = 3;
                    case 3:
                        _i++;
                        return [3, 1];
                    case 4: return [2, data];
                }
            });
        }); };
        var requestWithHook = function (key, input) { return __awaiter(void 0, void 0, void 0, function () {
            var hitHooks, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        hitHooks = _hooks.filter(function (v) { return v && (v.keys == '*' || v.keys.indexOf(key) != -1); });
                        res = null;
                        return [4, applyHook(hitHooks, 'before', key, input)];
                    case 1:
                        input = _a.sent();
                        if (!(__get_mode() == BridgeMode.Production)) return [3, 3];
                        return [4, __request(key, input)];
                    case 2:
                        res = _a.sent();
                        _a.label = 3;
                    case 3: return [4, applyHook(hitHooks, 'after', key, res)];
                    case 4:
                        res = _a.sent();
                        return [2, res];
                }
            });
        }); };
        var createHandle = function (key) {
            return function (input) { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, requestWithHook(key, input)];
                        case 1: return [2, _a.sent()];
                    }
                });
            }); };
        };
        var useHooks = function (hook) {
            _hooks.push(hook);
        };
        Object.keys(WebBridgeApiConstants).forEach(function (k) {
            _apis[k] = createHandle(k);
        });
        Object.assign(_apis, {
            version: "2.6.10",
            requestApi: requestWithHook,
            defineApi: __define,
            registerAppEvent: __registerAppEvent,
            useHooks: useHooks
        });
        var _handle = {
            set: function (_this, key, val) {
                return false;
            },
            get: function (_this, key) {
                if (!_this[key]) {
                    _this[key] = createHandle(key);
                }
                return _this[key];
            }
        };
        return new Proxy(_apis, _handle);
    })();
    proxy.useHooks(userHook);
    proxy.useHooks(defaultHook);

    return proxy;

})();
//# sourceMappingURL=ijsbridge.js.map
