export declare const TAG = "ijsbridge";
export declare enum WebBridgeApiConstants {
    /**
     * 请求
     */
    requireVersion = "requireVersion",
    /**
     * 系统属性
     */
    sysinfo = "sysinfo",
    /**
     * 扫描二维码
     */
    scanCode = "scanCode",
    /**
     * 授权登录
     */
    authorize = "authorize",
    /**
     * 获取本地用户
     */
    getUserInfo = "getUserInfo",
    /**
     * 网络请求(Deprecated)
     */
    fetch = "fetch",
    /**
     * 路由跳转
     */
    router = "router",
    /**
     * 本地小程序
     */
    showWebApp = "showWebApp",
    /**
     * 显示toast
     */
    showToast = "showToast",
    /**
     * 文本框
     */
    showDialog = "showDialog",
    /**
     * 选择本地图片、拍照
     */
    chooseImage = "chooseImage",
    /**
     * 选择本地视频、录像
     */
    chooseVideo = "chooseVideo",
    /**
     * 预览大图
     */
    showImageViewer = "showImageViewer",
    /**
     * 播放视频
     */
    showFullVideoPlayer = "showFullVideoPlayer",
    /**
     * 视频全屏
     */
    requestFullscreenVideoPlay = "requestFullscreenVideoPlay",
    /**
     * 请求权限
     */
    checkPermission = "checkPermission",
    /**
     * 录制音频
     */
    audioRecord = "audioRecord",
    /**
     * 分享
     */
    share = "share",
    /**
     * 打开外部链接
     */
    openLink = "openLink",
    /**
     * 显示picker菜单
     */
    showPickerMenu = "showPickerMenu",
    /**
     * 启动微信小程序
     */
    launchWechatProgram = "launchWechatProgram",
    /**
     * 获取定位信息
     */
    getCurrentPosition = "getCurrentPosition",
    /**
     * 网络请求
     */
    request = "request",
    /**
     * 注册全局事件
     */
    registerAppEvent = "registerAppEvent",
    /**
     * 注销全局事件
     */
    unRegisterAppEvent = "unRegisterAppEvent",
    /**
     * 触发全局事件
     */
    triggerAppEvent = "triggerAppEvent",
    /**
     * 旋转屏幕
     */
    orientation = "orientation",
    /**
     * 投屏
     */
    connectDlna = "connectDlna",
    /**
     * 锁屏声音控制
     */
    musicControl = "musicControl",
    /**
     * 读取文件(Core Version 1.6.5+)
     */
    readFile = "readFile",
    /**
     * 写文件(Core Version 1.6.5+)
     */
    saveFile = "saveFile",
    /**
     * 解压(Core Version 1.6.5+)
     */
    unzip = "unzip",
    /**
     * 文件存在(Core Version 1.6.5+)
     */
    fileExists = "fileExists",
    /**
     * 视频预览图(Core Version 1.6.5+)
     */
    previewVideo = "previewVideo",
    /**
     * 压缩视频(Core Version 1.6.5+)
     */
    compressVideo = "compressVideo",
    /**
     * 压缩图片(Core Version 1.6.5+)
     */
    compressImage = "compressImage",
    /**
     * 保存到相册(Core Version 1.6.5+)
     */
    saveToAlbum = "saveToAlbum",
    /**
     * 内容存储(Core Version 1.6.5+)
     */
    storage = "storage"
}
/**
 * 开发模式
 */
export declare enum BridgeMode {
    /**
     * 开发模式
     */
    Development = 1,
    /**
     * 生产模式
     */
    Production = 2,
    /**
     * 自动
     */
    Auto = 3
}
/**
 * 路由别名
 */
export declare enum SupportRouters {
    ad = "url",
    article = "detail",
    articlecate = "news_cate",
    articlecates = "news_tabs",
    govask = "govask_detail",
    live = "live_detail",
    liveindex = "live_index",
    news = "detail",
    ospsdetail = "govask_cate",
    ospsindex = "osps_index",
    radio = "radio",
    tv = "tv",
    url = "url",
    web = "url",
    zhengwuindex = "zhengwu_index",
    zw = "detail",
    newsclue = "newsclue",
    newscluedetail = "newscluedetail",
    snapshot = "snapshot",
    snapshotdetail = "snapshotdetail",
    yellow = "yellow"
}
export declare enum Events {
    /**
     * 唤起地址拦截（需要聚焦状态）
     */
    schemeOpen = "schemeOpen",
    /**
     * 摇一摇事件
     */
    shake = "shake",
    /**
     * 状态栏音频控制事件
     */
    onMusicControl = "onMusicControl",
    /**
     * 搜索事件
     */
    search = "search"
}
